build-scripts/checker-buildbot.sh
author Sam Lantinga
Tue, 10 Jan 2017 08:54:33 -0800
changeset 10806 36f40b8cc979
parent 10652 c3fbfa229d71
child 11170 b5fe34e8401f
permissions -rwxr-xr-x
Fixed bugs 2570, 3145, improved OpenGL ES context support on Windows and X11

Mark Callow

The attached patch does the following for the X11 and Windows platforms, the only ones where SDL attempts to use context_create_es_profile:

- Adds SDL_HINT_OPENGL_ES_DRIVER by which the application can
say to use the OpenGL ES driver & EGL rather than the Open GL
driver. (For bug #2570)
- Adds code to {WIN,X11}_GL_InitExtensions to determine the maximum
OpenGL ES version supported by the OpenGL driver (for bug #3145)
- Modifies the test that determines whether to use the OpenGL
driver or the real OpenGL ES driver to take into account the
hint, the requested and supported ES version and whether ES 1.X
is being requested. (For bug #2570 & bug #3145)
- Enables the testgles2 test for __WINDOWS__ and __LINUX__ and adds
the test to the VisualC projects.

With the fix in place I have run testdraw2, testgl and testgles2 without any issues and have run my own apps that use OpenGL, OpenGL ES 3 and OpenGL ES 1.1.
     1 #!/bin/bash
     2 
     3 # This is a script used by some Buildbot buildslaves to push the project
     4 #  through Clang's static analyzer and prepare the output to be uploaded
     5 #  back to the buildmaster. You might find it useful too.
     6 
     7 # Install Clang (you already have it on Mac OS X, apt-get install clang
     8 #  on Ubuntu, etc),
     9 # or download checker at http://clang-analyzer.llvm.org/ and unpack it in
    10 #  /usr/local ... update CHECKERDIR as appropriate.
    11 
    12 FINALDIR="$1"
    13 
    14 CHECKERDIR="/usr/local/checker-279"
    15 if [ ! -d "$CHECKERDIR" ]; then
    16     echo "$CHECKERDIR not found. Trying /usr/share/clang ..." 1>&2
    17     CHECKERDIR="/usr/share/clang/scan-build"
    18 fi
    19 
    20 if [ ! -d "$CHECKERDIR" ]; then
    21     echo "$CHECKERDIR not found. Giving up." 1>&2
    22     exit 1
    23 fi
    24 
    25 if [ -z "$MAKE" ]; then
    26     OSTYPE=`uname -s`
    27     if [ "$OSTYPE" == "Linux" ]; then
    28         NCPU=`cat /proc/cpuinfo |grep vendor_id |wc -l`
    29         let NCPU=$NCPU+1
    30     elif [ "$OSTYPE" = "Darwin" ]; then
    31         NCPU=`sysctl -n hw.ncpu`
    32     elif [ "$OSTYPE" = "SunOS" ]; then
    33         NCPU=`/usr/sbin/psrinfo |wc -l |sed -e 's/^ *//g;s/ *$//g'`
    34     else
    35         NCPU=1
    36     fi
    37 
    38     if [ -z "$NCPU" ]; then
    39         NCPU=1
    40     elif [ "$NCPU" = "0" ]; then
    41         NCPU=1
    42     fi
    43 
    44     MAKE="make -j$NCPU"
    45 fi
    46 
    47 echo "\$MAKE is '$MAKE'"
    48 
    49 # Unset $MAKE so submakes don't use it.
    50 MAKECOMMAND="$MAKE"
    51 unset MAKE
    52 
    53 set -x
    54 set -e
    55 
    56 cd `dirname "$0"`
    57 cd ..
    58 
    59 rm -rf checker-buildbot analysis
    60 if [ ! -z "$FINALDIR" ]; then
    61     rm -rf "$FINALDIR"
    62 fi
    63 
    64 mkdir checker-buildbot
    65 cd checker-buildbot
    66 
    67 # We turn off deprecated declarations, because we don't care about these warnings during static analysis.
    68 # The -Wno-liblto is new since our checker-279 upgrade, I think; checker otherwise warns "libLTO.dylib relative to clang installed dir not found"
    69 
    70 # You might want to do this for CMake-backed builds instead...
    71 PATH="$CHECKERDIR/bin:$PATH" scan-build -o analysis cmake -Wno-dev -DCMAKE_BUILD_TYPE=Debug -DASSERTIONS=enabled -DCMAKE_C_FLAGS="-Wno-deprecated-declarations" -DCMAKE_SHARED_LINKER_FLAGS="-Wno-liblto" ..
    72 
    73 # ...or run configure without the scan-build wrapper...
    74 #CC="$CHECKERDIR/libexec/ccc-analyzer" CFLAGS="-O0 -Wno-deprecated-declarations" LDFLAGS="-Wno-liblto" ../configure --enable-assertions=enabled
    75 
    76 rm -rf analysis
    77 PATH="$CHECKERDIR/bin:$PATH" scan-build -o analysis $MAKECOMMAND
    78 
    79 if [ `ls -A analysis |wc -l` == 0 ] ; then
    80     mkdir analysis/zarro
    81     echo '<html><head><title>Zarro boogs</title></head><body>Static analysis: no issues to report.</body></html>' >analysis/zarro/index.html
    82 fi
    83 
    84 mv analysis/* ../analysis
    85 rmdir analysis   # Make sure this is empty.
    86 cd ..
    87 chmod -R a+r analysis
    88 chmod -R go-w analysis
    89 find analysis -type d -exec chmod a+x {} \;
    90 if [ -x /usr/bin/xattr ]; then find analysis -exec /usr/bin/xattr -d com.apple.quarantine {} \; 2>/dev/null ; fi
    91 
    92 if [ ! -z "$FINALDIR" ]; then
    93     mv analysis "$FINALDIR"
    94 else
    95     FINALDIR=analysis
    96 fi
    97 
    98 rm -rf checker-buildbot
    99 
   100 echo "Done. Final output is in '$FINALDIR' ..."
   101 
   102 # end of checker-buildbot.sh ...
   103